/****************************************************************************
 **
 ** Copyright (C) 2011 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
 ** This file is part of the QtDeclarative module of the Qt Toolkit.
 **
 ** $QT_BEGIN_LICENSE:LGPL$
 ** No Commercial Usage
 ** This file contains pre-release code and may not be distributed.
 ** You may use this file in accordance with the terms and conditions
 ** contained in the Technology Preview License Agreement accompanying
 ** this package.
 **
 ** GNU Lesser General Public License Usage
 ** Alternatively, this file may be used under the terms of the GNU Lesser
 ** General Public License version 2.1 as published by the Free Software
 ** Foundation and appearing in the file LICENSE.LGPL included in the
 ** packaging of this file.  Please review the following information to
 ** ensure the GNU Lesser General Public License version 2.1 requirements
 ** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
 **
 ** In addition, as a special exception, Nokia gives you certain additional
 ** rights.  These rights are described in the Nokia Qt LGPL Exception
 ** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
 **
 ** If you have questions regarding the use of this file, please contact
 ** Nokia at qt-info@nokia.com.
 **
 **
 **
 **
 **
 **
 **
 **
 ** $QT_END_LICENSE$
 **
 ****************************************************************************/

#include "qdeclarativeaccessibility_p.h"

#include <qaccessible.h>
#include "qdeclarativeitem.h"

QT_BEGIN_NAMESPACE

QDeclarativeAccessibilityUpdater::QDeclarativeAccessibilityUpdater()
{
}

QDeclarativeAccessibilityUpdater::~QDeclarativeAccessibilityUpdater()
{

}

/*
// QSGItemChangeListener:
void QmlAccessibilityUpdateManager::itemGeometryChanged(QSGItem *item, const QRectF &, const QRectF &)
{
    locationChanged(item);
}

void QmlAccessibilityUpdateManager::itemSiblingOrderChanged(QSGItem *)
{

}

void QmlAccessibilityUpdateManager::itemVisibilityChanged(QSGItem *item)
{
    if (!QSGItemPrivate::get(item)->isAccessible)
        return;

    QAccessible::updateAccessibility(item, 0, item->isVisible() ? QAccessible::ObjectShow : QAccessible::ObjectHide );
}

void QmlAccessibilityUpdateManager::itemOpacityChanged(QSGItem *item)
{
    if (!QSGItemPrivate::get(item)->isAccessible)
        return;
    QAccessible::updateAccessibility(item, 0, qFuzzyIsNull(item->opacity()) ?  QAccessible::ObjectShow : QAccessible::ObjectHide );
}

void QmlAccessibilityUpdateManager::itemDestroyed(QSGItem *item)
{
    QAccessible::updateAccessibility(item, 0, QAccessible::ObjectDestroyed);
}
*/

void QDeclarativeAccessibilityUpdater::itemSiblingOrderChanged(QDeclarativeItem *)
{

}

void QDeclarativeAccessibilityUpdater::itemVisibilityChanged(QDeclarativeItem *item)
{
    QAccessible::updateAccessibility(item, 0, item->isVisible() ? QAccessible::ObjectShow : QAccessible::ObjectHide );
}

void QDeclarativeAccessibilityUpdater::itemOpacityChanged(QDeclarativeItem *item)
{
    QAccessible::updateAccessibility(item, 0, qFuzzyIsNull(item->opacity()) ?  QAccessible::ObjectShow : QAccessible::ObjectHide );
}

void QDeclarativeAccessibilityUpdater::itemDestroyed(QDeclarativeItem *item)
{
    QAccessible::updateAccessibility(item, 0, QAccessible::ObjectDestroyed);
}

bool QDeclarativeAccessibilityUpdater::isAccessible(QObject *object)
{
/*     if (QSGItem *item = qobject_cast<QSGItem *>(object)) {
        return QSGItemPrivate::get(item)->isAccessible;
     } else
*/
    {
        // QDeclarativeItem
        return true;
     }
}

QObject *QDeclarativeAccessibilityUpdater::parent(QObject *object)
{
/*
    if (QSGItem *item = qobject_cast<QSGItem *>(object)) {
        return item->parentItem();
     } else
*/
     {
        // QDeclarativeItem
        return 0;
     }
}

QT_END_NAMESPACE
