#ifndef QACCESSIBLEDECLARATIVEIMPLEMENTATION_H
#define QACCESSIBLEDECLARATIVEIMPLEMENTATION_H

#include <qaccessibleobject.h>

#ifndef QT_NO_ACCESSIBILITY

class QAccessibleDeclarativeObject;
class QAccessibleDeclarativeImplementation
{
public:
    QAccessibleDeclarativeImplementation();
    void setBaseObject(QAccessibleObjectEx *accessibleObject);

    /* geometry */
    virtual QRect itemRect() const = 0;
    virtual QRect viewRect() const = 0;

    /* hit testing */
    virtual bool clipsChildren() const = 0;

    /* hierarchy */
    virtual int childCount() const = 0;
    virtual int navigate(QAccessible::RelationFlag rel, int entry, QAccessibleInterface **target) const = 0;
    virtual int indexOfChild(const QAccessibleInterface *iface) const = 0;

    virtual QFlags<QAccessible::StateFlag> state() const = 0;
    virtual bool isAccessible() const  = 0;
protected:
    QAccessibleObjectEx *m_accessibleObject;
};

#endif // QT_NO_ACCESSIBILITY

QT_END_NAMESPACE

#endif // QACCESSIBLEDECLARATIVEIMPLEMENTATION_H
