#ifndef QACCESSIBLEGRAPHICSVIEWIMPLEMENTATION_H
#define QACCESSIBLEGRAPHICSVIEWIMPLEMENTATION_H

#include "qaccessibledeclarativeimplementation.h"
#include <QGraphicsView>
#include <QGraphicsItem>

class QAccessibleGraphicsViewImplementation : public QAccessibleDeclarativeImplementation
{
public:
    QAccessibleGraphicsViewImplementation(QGraphicsItem *item, QGraphicsView *view);
    static QAccessibleDeclarativeObject *instantiateObject(QGraphicsObject *item, QGraphicsView *view);

    QRect itemRect() const;
    QRect viewRect() const;

    bool clipsChildren() const;

    int childCount() const;
    int navigate(QAccessible::RelationFlag rel, int entry, QAccessibleInterface **target) const;
    int indexOfChild(const QAccessibleInterface *iface) const;

    QFlags<QAccessible::StateFlag> state() const;
    virtual bool isAccessible() const;
private:
   QGraphicsItem *m_item;
   QGraphicsView *m_view;
};

#endif // QACCESSIBLEGRAPHICSVIEWIMPLEMENTATION_H
