#ifndef ACCESSIBILITYINSPECTOR_H
#define ACCESSIBILITYINSPECTOR_H

#include <QObject>
#include <qgraphicsscene.h>
#include <QAccessible>

QString translateRole(QAccessible::Role role);

class OptionsWidget;
class MouseInterceptingGraphicsScene;
class QGraphicsView;
class QGraphicsScene;
class AccessibilitySceneManager;
class ScreenReader;
class AccessibilityInspector : public QObject
{
    Q_OBJECT
public:
    explicit AccessibilityInspector(QObject *parent = 0);
    ~AccessibilityInspector();
    void inspectWindow(QWidget *window);
    void saveWindowGeometry();
signals:

public slots:

private:
    OptionsWidget *optionsWidget;
    MouseInterceptingGraphicsScene *accessibilityScene;
    QGraphicsView *accessibilityView;
    QGraphicsScene *accessibilityTreeScene;
    QGraphicsView *accessibilityTreeView;
    ScreenReader *screenReader;
};

class MouseInterceptingGraphicsScene : public QGraphicsScene
{
Q_OBJECT
protected:
    virtual void mousePressEvent(QGraphicsSceneMouseEvent *event);
    virtual void mouseDoubleClickEvent(QGraphicsSceneMouseEvent *event);
signals:
    void mousePressed(const QPoint point);
    void mouseDobleClicked();
};

#endif // ACCESSIBILITYINSPECTOR_H
